Bug 810257 - systemd-tmpfiles does not preserve atime of subdirectories
Summary: systemd-tmpfiles does not preserve atime of subdirectories
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: systemd
Version: 16
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: systemd-maint
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 468670
TreeView+ depends on / blocked
 
Reported: 2012-04-05 13:27 UTC by Miloslav Trmač
Modified: 2012-06-05 23:10 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-05-29 10:34:07 UTC
Type: Bug


Attachments (Terms of Use)

Description Miloslav Trmač 2012-04-05 13:27:54 UTC
Version-Release number of selected component (if applicable):
systemd-37-17.fc16.x86_64 and, AFAICS, current upstream git

Steps to reproduce:
> # LC_ALL=C stat /tmp/virtual-mitr.xcx2wx/ |grep ': 2012'
> Access: 2012-03-31 15:24:35.818233723 +0200
> Modify: 2012-03-31 15:24:35.818233723 +0200
> Change: 2012-04-05 15:24:35.818056217 +0200
> # LC_ALL=C date; /bin/systemd-tmpfiles --clean
> Thu Apr  5 15:25:34 CEST 2012
> Successfully loaded SELinux database in 8ms 343us, size on heap is 482K.

Actual results:
> # LC_ALL=C stat /tmp/virtual-mitr.xcx2wx/ |grep ': 2'
> Device: fd02h/64770d	Inode: 18088068    Links: 2
> Access: 2012-04-05 15:25:34.191942631 +0200
> Modify: 2012-03-31 15:24:35.818233723 +0200
> Change: 2012-04-05 15:24:35.818056217 +0200

Expected results:
atime preserved

Additional info:
This means that systemd-tmpwatch never removes the subdirectory, and prevents tmpwatch for removing it as well.

From a quick look, this should be unconditional:
>        if (deleted) {
>                /* Restore original directory timestamps */

Comment 1 Miloslav Trmač 2012-04-05 13:45:56 UTC
FWIW, when testing this, keep in mind that the default for ext* is "relatime", so if atime is less than one day in the past, it won't be updated.

Comment 2 Kay Sievers 2012-04-11 19:59:35 UTC
Fix is in systemd git now. Thanks!

http://cgit.freedesktop.org/systemd/systemd/commit/?id=e5f3d1ba124f14477d6b5434982d7d44a472a66f

Comment 3 Fedora Update System 2012-05-18 23:38:24 UTC
systemd-44-9.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/systemd-44-9.fc17

Comment 4 Fedora Update System 2012-05-18 23:57:31 UTC
systemd-37-20.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/systemd-37-20.fc16

Comment 5 Fedora Update System 2012-05-19 18:33:37 UTC
Package systemd-44-9.fc17:
* should fix your issue,
* was pushed to the Fedora 17 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing systemd-44-9.fc17'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-8127/systemd-44-9.fc17
then log in and leave karma (feedback).

Comment 6 Fedora Update System 2012-05-29 10:34:07 UTC
systemd-44-12.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 7 Fedora Update System 2012-06-05 23:10:47 UTC
systemd-37-25.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.